const styles=new CSSStyleSheet;styles.replaceSync('/*\n * Copyright (C) 2006, 2007, 2008 Apple Inc.  All rights reserved.\n * Copyright (C) 2009 Anthony Ricaud <rik@webkit.org>\n *\n * Redistribution and use in source and binary forms, with or without\n * modification, are permitted provided that the following conditions\n * are met:\n *\n * 1.  Redistributions of source code must retain the above copyright\n *     notice, this list of conditions and the following disclaimer.\n * 2.  Redistributions in binary form must reproduce the above copyright\n *     notice, this list of conditions and the following disclaimer in the\n *     documentation and/or other materials provided with the distribution.\n * 3.  Neither the name of Apple Computer, Inc. ("Apple") nor the names of\n *     its contributors may be used to endorse or promote products derived\n *     from this software without specific prior written permission.\n *\n * THIS SOFTWARE IS PROVIDED BY APPLE AND ITS CONTRIBUTORS "AS IS" AND ANY\n * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED\n * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE\n * DISCLAIMED. IN NO EVENT SHALL APPLE OR ITS CONTRIBUTORS BE LIABLE FOR ANY\n * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES\n * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;\n * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND\n * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT\n * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF\n * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\n */\n\n.console-view {\n  background-color: var(--sys-color-cdt-base-container);\n  overflow: hidden;\n\n  --override-error-text-color: var(--color-error-text);\n  --override-console-error-background-color: var(--color-error-background);\n  --override-error-border-color: var(--color-error-border);\n  --override-message-border-color: rgb(240 240 240);\n  --override-warning-border-color: hsl(50deg 100% 88%);\n  --override-focused-message-border-color: hsl(214deg 67% 88%);\n  --override-focused-message-background-color: hsl(214deg 48% 95%);\n  --override-console-warning-text-color: hsl(39deg 100% 18%);\n  --message-corner-rounder-background: (--sys-color-cdt-base-container);\n}\n\n.-theme-with-dark-background .console-view {\n  --override-message-border-color: rgb(58 58 58);\n  --override-warning-border-color: rgb(102 85 0);\n  --override-focused-message-border-color: hsl(214deg 47% 48%);\n  --override-focused-message-background-color: hsl(214deg 19% 20%);\n  --override-console-warning-text-color: hsl(39deg 89% 55%);\n  --override-console-link-color: var(--color-background-inverted);\n}\n\n.console-toolbar-container {\n  display: flex;\n  flex: none;\n}\n\n.console-main-toolbar {\n  flex: 1 1 auto;\n}\n\n.console-toolbar-container > .toolbar {\n  background-color: var(--sys-color-cdt-base-container);\n  border-bottom: 1px solid var(--sys-color-divider);\n}\n\n.console-view-fix-select-all {\n  height: 0;\n  overflow: hidden;\n}\n\n.console-settings-pane {\n  flex: none;\n  background-color: var(--sys-color-cdt-base-container);\n  border-bottom: 1px solid var(--sys-color-divider);\n}\n\n.console-settings-pane .toolbar {\n  flex: 1 1;\n}\n\n#console-messages {\n  flex: 1 1;\n  overflow-y: auto;\n  word-wrap: break-word;\n  user-select: text;\n  transform: translateZ(0);\n  overflow-anchor: none;  /* Chrome-specific scroll-anchoring opt-out */\n  background-color: var(--sys-color-cdt-base-container);\n}\n\n#console-prompt {\n  clear: right;\n  position: relative;\n  margin: 0 22px 0 20px;\n}\n\n.console-prompt-editor-container {\n  min-height: 21px;\n}\n\n.console-message,\n.console-user-command {\n  clear: right;\n  position: relative;\n  padding: 3px 22px 1px 0;\n  margin-left: 24px;\n  min-height: 17px;  /* Sync with ConsoleViewMessage.js */\n  flex: auto;\n  display: flex;\n}\n\n.console-message > * {\n  flex: auto;\n}\n\n.console-timestamp {\n  color: var(--color-text-secondary);\n  user-select: none;\n  flex: none;\n  margin-right: 5px;\n}\n\n.message-level-icon,\n.command-result-icon {\n  position: absolute;\n  left: -17px;\n  top: 2px;\n  user-select: none;\n}\n\n.console-message-repeat-count {\n  margin: 2px 0 0 10px;\n  flex: none;\n}\n\n.repeated-message {\n  margin-left: 4px;\n}\n\n.repeated-message .message-level-icon {\n  display: none;\n}\n\n.console-message-stack-trace-toggle {\n  display: flex;\n  flex-direction: row;\n  align-items: flex-start;\n}\n\n.repeated-message .console-message-stack-trace-toggle,\n.repeated-message > .console-message-text {\n  flex: 1;\n}\n\n.console-error-level .repeated-message,\n.console-warning-level .repeated-message,\n.console-verbose-level .repeated-message,\n.console-info-level .repeated-message {\n  display: flex;\n}\n\n.console-info {\n  color: var(--color-text-secondary);\n  font-style: italic;\n  padding-bottom: 2px;\n}\n\n.console-group .console-group > .console-group-messages {\n  margin-left: 16px;\n}\n\n.console-group-title.console-from-api {\n  font-weight: bold;\n}\n\n.console-group-title .console-message {\n  margin-left: 12px;\n}\n\n.expand-group-icon {\n  user-select: none;\n  flex: none;\n  position: relative;\n  left: 8px;\n  top: 3px;\n  margin-right: 2px;\n}\n\n.console-group-title .message-level-icon {\n  display: none;\n}\n\n.console-message-repeat-count .expand-group-icon {\n  position: static;\n  background-color: var(--sys-color-cdt-base-container);\n  margin-left: -1px;\n}\n\n.console-group {\n  position: relative;\n}\n\n.console-message-wrapper {\n  display: flex;\n  margin: 4px;\n  border-radius: 5px;\n\n  /* Console ANSI color */\n  --console-color-black: #000;\n  --console-color-red: #a00;\n  --console-color-green: #0a0;\n  --console-color-yellow: #a50;\n  --console-color-blue: #00a;\n  --console-color-magenta: #a0a;\n  --console-color-cyan: #0aa;\n  --console-color-gray: #aaa;\n  --console-color-darkgray: #555;\n  --console-color-lightred: #f55;\n  --console-color-lightgreen: #5f5;\n  --console-color-lightyellow: #ff5;\n  --console-color-lightblue: #55f;\n  --console-color-ightmagenta: #f5f;\n  --console-color-lightcyan: #5ff;\n  --console-color-white: #fff;\n\n  &:focus {\n    background-color: var(--override-focused-message-background-color);\n  }\n}\n\n.-theme-with-dark-background .console-message-wrapper {\n  /* Dark theme console ANSI color */\n  --console-color-red: rgb(237 78 76);\n  --console-color-green: rgb(1 200 1);\n  --console-color-yellow: rgb(210 192 87);\n  --console-color-blue: rgb(39 116 240);\n  --console-color-magenta: rgb(161 66 244);\n  --console-color-cyan: rgb(18 181 203);\n  --console-color-gray: rgb(207 208 208);\n  --console-color-darkgray: rgb(137 137 137);\n  --console-color-lightred: rgb(242 139 130);\n  --console-color-lightgreen: rgb(161 247 181);\n  --console-color-lightyellow: rgb(221 251 85);\n  --console-color-lightblue: rgb(102 157 246);\n  --console-color-lightmagenta: rgb(214 112 214);\n  --console-color-lightcyan: rgb(132 240 255);\n}\n\n.console-message-wrapper.console-warning-level + .console-message-wrapper,\n.console-message-wrapper.console-error-level + .console-message-wrapper {\n  & .console-message::before,\n  & .console-user-command::before {\n    display: none !important; /* stylelint-disable-line declaration-no-important */\n  }\n}\n\n.console-message-wrapper:not(.console-error-level):not(.console-warning-level) {\n  & .console-message::before,\n  & .console-user-command::before {\n    width: calc(100% - 25px);\n    content: "";\n    display: block;\n    position: absolute;\n    top: -2px;\n    border-top: 1px solid var(--sys-color-divider);\n  }\n\n  &:first-of-type .console-message::before,\n  &:first-of-type .console-user-command::before {\n    display: none;\n  }\n}\n\n.console-message-wrapper.console-adjacent-user-command-result:not(.console-error-level):not(.console-warning-level) {\n  border-top-width: 0;\n}\n\n.console-message-wrapper:focus + .console-message-wrapper {\n  border-top-color: transparent;\n}\n\n.console-message-wrapper.console-adjacent-user-command-result:not(.console-error-level):not(.console-warning-level):focus {\n  border-top-width: 1px;\n}\n\n.console-message-wrapper.console-adjacent-user-command-result:not(.console-error-level):not(.console-warning-level):focus .console-message {\n  padding-top: 2px;\n  min-height: 16px;\n}\n\n.console-message-wrapper.console-adjacent-user-command-result:not(.console-error-level):not(.console-warning-level):focus .command-result-icon {\n  top: 3px;\n}\n\n.console-message-wrapper.console-error-level:focus {\n  --override-error-text-color: rgb(200 0 0);\n}\n\n.-theme-with-dark-background .console-message-wrapper.console-error-level:focus {\n  --override-error-text-color: hsl(0deg 100% 75%);\n}\n\n.console-message-wrapper .nesting-level-marker {\n  width: 14px;\n  flex: 0 0 auto;\n  position: relative;\n  margin-bottom: -1px;\n  margin-top: -1px;\n  background-color: var(--sys-color-cdt-base-container);\n}\n\n.console-message-wrapper .nesting-level-marker + .console-message::after {\n  position: absolute;\n  left: -30px;\n  top: 0;\n  width: 6px;\n  height: 100%;\n  box-sizing: border-box;\n  background-color: var(--sys-color-surface-yellow);\n  border-top-left-radius: 5px;\n  border-bottom-left-radius: 5px;\n  content: "";\n}\n\n.console-error-level {\n  background-color: var(--sys-color-surface-error);\n\n  --message-corner-rounder-background: var(--sys-color-surface-error);\n}\n\n.console-warning-level {\n  background-color: var(--sys-color-surface-yellow);\n\n  --message-corner-rounder-background: var(--sys-color-surface-yellow);\n}\n\n.console-warning-level .console-message-text {\n  color: var(--override-console-warning-text-color);\n}\n\n.console-view-object-properties-section {\n  padding: 0;\n  position: relative;\n  vertical-align: baseline;\n  color: inherit;\n  display: inline-block;\n  overflow-wrap: break-word;\n  max-width: 100%;\n}\n\n.info-note {\n  background-color: var(--color-primary-variant);\n}\n\n.info-note::before {\n  content: "i";\n}\n\n.console-view-object-properties-section:not(.expanded) .info-note {\n  display: none;\n}\n\n.console-error-level .console-message-text,\n.console-error-level .console-view-object-properties-section {\n  color: var(--override-error-text-color) !important; /* stylelint-disable-line declaration-no-important */\n}\n\n.console-system-type.console-info-level {\n  color: #00f; /* stylelint-disable-line plugin/use_theme_colors */\n  /* See: crbug.com/1152736 for color variable migration. */\n}\n\n.-theme-with-dark-background .console-verbose-level:not(.console-warning-level) .console-message-text,\n.-theme-with-dark-background .console-system-type.console-info-level {\n  color: hsl(220deg 100% 65%) !important; /* stylelint-disable-line declaration-no-important */\n}\n\n#console-messages .link {\n  cursor: pointer;\n  text-decoration: underline;\n}\n\n#console-messages .link,\n#console-messages .devtools-link {\n  color: var(--color-text-secondary);\n  word-break: break-all;\n}\n\n#console-messages .resource-links {\n  margin-top: -1px;\n  margin-bottom: -2px;\n}\n\n#console-messages .link:hover,\n#console-messages .devtools-link:hover {\n  color: var(--color-text-primary);\n}\n\n.console-object-preview {\n  white-space: normal;\n  word-wrap: break-word;\n  font-style: italic;\n}\n\n.console-object-preview .name {\n  flex-shrink: 0;\n}\n\n.console-message-text .object-value-node {\n  display: inline-block;\n}\n\n.console-message-text .object-value-string,\n.console-message-text .object-value-regexp,\n.console-message-text .object-value-symbol {\n  white-space: pre-wrap;\n  word-break: break-all;\n}\n\n.console-message-formatted-table {\n  clear: both;\n}\n\n.console-message .source-code {\n  line-height: 1.2;\n}\n\n.console-message-anchor {\n  float: right;\n  text-align: right;\n  max-width: 100%;\n  margin-left: 4px;\n}\n\n.console-message-badge {\n  float: right;\n  margin-left: 4px;\n}\n\n.console-message-nowrap-below,\n.console-message-nowrap-below div,\n.console-message-nowrap-below span {\n  white-space: nowrap !important; /* stylelint-disable-line declaration-no-important */\n}\n\n.object-state-note {\n  display: inline-block;\n  width: 11px;\n  height: 11px;\n  color: var(--color-background);\n  text-align: center;\n  border-radius: 3px;\n  line-height: 13px;\n  margin: 0 6px;\n  font-size: 9px;\n}\n\n.-theme-with-dark-background .object-state-note {\n  background-color: hsl(230deg 100% 80%);\n}\n\n.console-object {\n  white-space: pre-wrap;\n  word-break: break-all;\n}\n\n.console-message-stack-trace-wrapper {\n  flex: 1 1 auto;\n  display: flex;\n  flex-direction: column;\n  align-items: stretch;\n}\n\n.console-message-stack-trace-wrapper > * {\n  flex: none;\n}\n\n.console-message-expand-icon {\n  margin-bottom: -4px;\n}\n\n.console-searchable-view {\n  max-height: 100%;\n}\n\n.console-view-pinpane {\n  flex: none;\n  max-height: 50%;\n}\n\n/* We are setting width and height to 0px to essentially hide the html element on the UI but visible to the screen reader.\n This html element is used by screen readers when console messages are filtered, instead of screen readers reading\n contents of the filtered messages we only want the screen readers to read the count of filtered messages. */\n.message-count {\n  width: 0;\n  height: 0;\n}\n\n.-theme-with-dark-background #console-messages .console-message-text .devtools-link {\n  color: var(--override-console-link-color);\n}\n\n@media (forced-colors: active) {\n  .console-message-expand-icon,\n  .console-warning-level [is="ui-icon"].icon-mask.expand-group-icon {\n    forced-color-adjust: none;\n    background-color: ButtonText;\n  }\n\n  .console-message-wrapper:focus,\n  .console-message-wrapper:focus:last-of-type {\n    forced-color-adjust: none;\n    background-color: Highlight;\n    border-top-color: Highlight;\n    border-bottom-color: Highlight;\n  }\n\n  .console-message-wrapper:focus *,\n  .console-message-wrapper:focus:last-of-type *,\n  .console-message-wrapper:focus .devtools-link,\n  .console-message-wrapper:focus:last-of-type .devtools-link {\n    color: HighlightText !important; /* stylelint-disable-line declaration-no-important */\n  }\n\n  #console-messages .devtools-link,\n  #console-messages .devtools-link:hover {\n    color: linktext;\n  }\n\n  #console-messages .link:focus-visible,\n  #console-messages .devtools-link:focus-visible {\n    background: Highlight;\n    color: HighlightText;\n  }\n\n  .console-message-wrapper:focus [is="ui-icon"].icon-mask {\n    background-color: HighlightText;\n  }\n\n  .console-message-wrapper.console-error-level:focus,\n  .console-message-wrapper.console-error-level:focus:last-of-type {\n    --override-error-text-color: HighlightText;\n  }\n\n  .console-message-anchor .resource-links {\n    --icon-color: ButtonText;\n  }\n}\n\n/*# sourceURL=consoleView.css */\n');export default styles;