const styles=new CSSStyleSheet;styles.replaceSync('/*\n * Copyright 2023 The Chromium Authors. All rights reserved.\n * Use of this source code is governed by a BSD-style license that can be\n * found in the LICENSE file.\n */\n\n* {\n  padding: 0;\n  margin: 0;\n  box-sizing: border-box;\n  font-size: inherit;\n}\n\n.wrapper {\n  display: flex;\n  flex-direction: row;\n  flex: 1;\n  height: 100%;\n}\n\n.main {\n  overflow: hidden;\n  display: flex;\n  flex-direction: column;\n  flex: 1;\n}\n\n.sections {\n  flex: 1;\n  min-height: 0;\n  overflow: hidden auto;\n  background-color: var(--sys-color-cdt-base-container);\n  z-index: 0;\n  position: relative;\n  container: sections / inline-size; /* stylelint-disable-line property-no-unknown */\n}\n\n.section {\n  display: flex;\n  padding: 0 16px;\n  gap: 8px;\n  position: relative;\n}\n\n.section::after {\n  content: "";\n  border-bottom: 1px solid var(--sys-color-divider);\n  position: absolute;\n  left: 0;\n  right: 0;\n  bottom: 0;\n  z-index: -1;\n}\n\n.section:last-child {\n  /* Make sure there is enough space for the context menu. */\n  margin-bottom: 70px;\n}\n\n.section:last-child::after {\n  content: none;\n}\n\n.screenshot-wrapper {\n  flex: 0 0 80px;\n  padding-top: 32px;\n  z-index: 2; /* We want this to be on top of \\\'.step-overlay\\\' */\n}\n\n/* stylelint-disable-next-line at-rule-no-unknown */\n@container sections (max-width: 400px) {\n  .screenshot-wrapper {\n    display: none;\n  }\n}\n\n.screenshot {\n  object-fit: cover;\n  object-position: top center;\n  max-width: 100%;\n  width: 200px;\n  height: auto;\n  border: 1px solid var(--sys-color-divider);\n  border-radius: 1px;\n}\n\n.content {\n  flex: 1;\n  min-width: 0;\n}\n\n.steps {\n  flex: 1;\n  position: relative;\n  align-self: flex-start;\n  overflow: visible;\n}\n\n.step {\n  position: relative;\n  padding-left: 40px;\n  margin: 16px 0;\n}\n\n.step .action {\n  font-size: 13px;\n  line-height: 16px;\n  letter-spacing: 0.03em;\n}\n\n.recording {\n  color: var(--sys-color-primary);\n  font-style: italic;\n  margin-top: 8px;\n  margin-bottom: 0;\n}\n\n.add-assertion-button {\n  margin-top: 8px;\n}\n\n.details {\n  max-width: 240px;\n  display: flex;\n  flex-direction: column;\n  align-items: flex-end;\n}\n\n.url {\n  font-size: 12px;\n  line-height: 16px;\n  letter-spacing: 0.03em;\n  white-space: nowrap;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  color: var(--sys-color-secondary);\n  max-width: 100%;\n  margin-bottom: 16px;\n}\n\n.header {\n  align-items: center;\n  border-bottom: 1px solid var(--sys-color-divider);\n  display: flex;\n  flex-wrap: wrap;\n  gap: 10px;\n  justify-content: space-between;\n  padding: 16px;\n}\n\n.header-title-wrapper {\n  max-width: 100%;\n}\n\n.header-title {\n  align-items: center;\n  display: flex;\n  flex: 1;\n  max-width: 100%;\n}\n\n.header-title::before {\n  content: "";\n  min-width: 12px;\n  height: 12px;\n  display: inline-block;\n  background: var(--sys-color-primary);\n  border-radius: 50%;\n  margin-right: 7px;\n}\n\n#title-input {\n  box-sizing: content-box;\n  font-family: inherit;\n  font-size: 18px;\n  line-height: 22px;\n  letter-spacing: 0.02em;\n  padding: 1px 4px;\n  border: 1px solid transparent;\n  border-radius: 1px;\n  word-break: break-all;\n}\n\n#title-input:hover {\n  border-color: var(--input-outline);\n}\n\n#title-input.has-error {\n  border-color: var(--sys-color-error);\n}\n\n#title-input.disabled {\n  color: var(--sys-color-state-disabled);\n}\n\n.title-input-error-text {\n  margin-top: 4px;\n  margin-left: 19px;\n  color: var(--sys-color-error);\n}\n\n.title-button-bar {\n  padding-left: 2px;\n  display: flex;\n}\n\n#title-input:focus + .title-button-bar {\n  display: none;\n}\n\n.settings-row {\n  padding: 16px 28px;\n  border-bottom: 1px solid var(--sys-color-divider);\n  display: flex;\n  flex-flow: row wrap;\n  justify-content: space-between;\n}\n\n.settings-title {\n  font-size: 14px;\n  line-height: 24px;\n  letter-spacing: 0.03em;\n  color: var(--sys-color-on-surface);\n  display: flex;\n  align-items: center;\n  align-content: center;\n  gap: 5px;\n}\n\n.settings {\n  margin-top: 4px;\n  display: flex;\n  font-size: 12px;\n  line-height: 20px;\n  letter-spacing: 0.03em;\n  color: var(--sys-color-on-surface-subtle);\n}\n\n.settings.expanded {\n  gap: 10px;\n}\n\n.settings .separator {\n  width: 1px;\n  height: 20px;\n  background-color: var(--sys-color-divider);\n  margin: 0 5px;\n}\n\n.actions {\n  display: flex;\n  align-items: center;\n  flex-wrap: wrap;\n  gap: 12px;\n}\n\n.is-recording .header-title::before {\n  background: var(--sys-color-error);\n}\n\n.footer {\n  display: flex;\n  justify-content: center;\n  border-top: 1px solid var(--sys-color-divider);\n  padding: 12px;\n  background: var(--sys-color-cdt-base-container);\n  z-index: 1;\n}\n\n.controls {\n  align-items: center;\n  display: flex;\n  justify-content: center;\n  position: relative;\n  width: 100%;\n}\n\n.chevron {\n  width: 14px;\n  height: 14px;\n  transform: rotate(-90deg);\n}\n\n.expanded .chevron {\n  transform: rotate(0);\n}\n\n.editable-setting {\n  display: flex;\n  flex-direction: row;\n  gap: 12px;\n  align-items: center;\n}\n\n.editable-setting devtools-select-menu {\n  height: 32px;\n}\n\n.editable-setting .devtools-text-input {\n  width: fit-content;\n}\n\n.wrapping-label {\n  display: inline-flex;\n  align-items: center;\n  gap: 12px;\n}\n\n.text-editor {\n  height: 100%;\n  overflow: auto;\n}\n\n.section-toolbar {\n  display: flex;\n  padding: 3px;\n  justify-content: space-between;\n  gap: 3px;\n}\n\n.section-toolbar > devtools-select-menu {\n  min-width: 50px;\n}\n\n.sections .section-toolbar {\n  justify-content: flex-end;\n}\n\n.section-toolbar > * {\n  height: 24px;\n}\n\ndevtools-split-view {\n  flex: 1 1 0%;\n  min-height: 0;\n}\n\n[slot="sidebar"] {\n  display: flex;\n  flex-direction: column;\n  overflow: auto;\n  height: 100%;\n  width: 100%;\n}\n\n[slot="sidebar"] .section-toolbar {\n  border-bottom: 1px solid var(--sys-color-divider);\n}\n\n.show-code {\n  margin-right: 14px;\n  margin-top: 8px;\n}\n\ndevtools-recorder-extension-view {\n  flex: 1;\n}\n\n/*# sourceURL=recordingView.css */\n');export default styles;