import{headersArray,HTTPRequest as BaseHTTPRequest,InterceptResolutionAction,STATUS_TEXTS}from"../api/HTTPRequest.js";import{assert}from"../util/assert.js";import{debugError,isString}from"./util.js";export class HTTPRequest extends BaseHTTPRequest{_requestId;_interceptionId;_failureText=null;_response=null;_fromMemoryCache=!1;_redirectChain;#e;#t;#i;#n=!1;#r;#s;#o;#a;#c={};#d;#u;#l=null;#h=null;#p={action:InterceptResolutionAction.None};#R;#f;get client(){return this.#e}constructor(e,t,i,n,r,s){super(),this.#e=e,this._requestId=r.requestId,this.#t=r.requestId===r.loaderId&&"Document"===r.type,this._interceptionId=i,this.#i=n,this.#r=r.request.url,this.#s=(r.type||"other").toLowerCase(),this.#o=r.request.method,this.#a=r.request.postData,this.#d=t,this._redirectChain=s,this.#u={},this.#R=[],this.#f=r.initiator;for(const[e,t]of Object.entries(r.request.headers))this.#c[e.toLowerCase()]=t}url(){return this.#r}continueRequestOverrides(){return assert(this.#i,"Request Interception is not enabled!"),this.#u}responseForRequest(){return assert(this.#i,"Request Interception is not enabled!"),this.#l}abortErrorReason(){return assert(this.#i,"Request Interception is not enabled!"),this.#h}interceptResolutionState(){return this.#i?this.#n?{action:InterceptResolutionAction.AlreadyHandled}:{...this.#p}:{action:InterceptResolutionAction.Disabled}}isInterceptResolutionHandled(){return this.#n}enqueueInterceptAction(e){this.#R.push(e)}async finalizeInterceptions(){await this.#R.reduce(((e,t)=>e.then(t)),Promise.resolve());const{action:e}=this.interceptResolutionState();switch(e){case"abort":return this.#q(this.#h);case"respond":if(null===this.#l)throw new Error("Response is missing for the interception");return this.#y(this.#l);case"continue":return this.#I(this.#u)}}resourceType(){return this.#s}method(){return this.#o}postData(){return this.#a}headers(){return this.#c}response(){return this._response}frame(){return this.#d}isNavigationRequest(){return this.#t}initiator(){return this.#f}redirectChain(){return this._redirectChain.slice()}failure(){return this._failureText?{errorText:this._failureText}:null}async continue(e={},t){if(!this.#r.startsWith("data:")){if(assert(this.#i,"Request Interception is not enabled!"),assert(!this.#n,"Request is already handled!"),void 0===t)return this.#I(e);if(this.#u=e,void 0===this.#p.priority||t>this.#p.priority)this.#p={action:InterceptResolutionAction.Continue,priority:t};else if(t===this.#p.priority){if("abort"===this.#p.action||"respond"===this.#p.action)return;this.#p.action=InterceptResolutionAction.Continue}}}async#I(e={}){const{url:t,method:i,postData:n,headers:r}=e;this.#n=!0;const s=n?Buffer.from(n).toString("base64"):void 0;if(void 0===this._interceptionId)throw new Error("HTTPRequest is missing _interceptionId needed for Fetch.continueRequest");await this.#e.send("Fetch.continueRequest",{requestId:this._interceptionId,url:t,method:i,postData:s,headers:r?headersArray(r):void 0}).catch((e=>(this.#n=!1,handleError(e))))}async respond(e,t){if(!this.#r.startsWith("data:")){if(assert(this.#i,"Request Interception is not enabled!"),assert(!this.#n,"Request is already handled!"),void 0===t)return this.#y(e);if(this.#l=e,void 0===this.#p.priority||t>this.#p.priority)this.#p={action:InterceptResolutionAction.Respond,priority:t};else if(t===this.#p.priority){if("abort"===this.#p.action)return;this.#p.action=InterceptResolutionAction.Respond}}}async#y(e){this.#n=!0;const t=e.body&&isString(e.body)?Buffer.from(e.body):e.body||null,i={};if(e.headers)for(const t of Object.keys(e.headers)){const n=e.headers[t];i[t.toLowerCase()]=Array.isArray(n)?n.map((e=>String(e))):String(n)}e.contentType&&(i["content-type"]=e.contentType),t&&!("content-length"in i)&&(i["content-length"]=String(Buffer.byteLength(t)));const n=e.status||200;if(void 0===this._interceptionId)throw new Error("HTTPRequest is missing _interceptionId needed for Fetch.fulfillRequest");await this.#e.send("Fetch.fulfillRequest",{requestId:this._interceptionId,responseCode:n,responsePhrase:STATUS_TEXTS[n],responseHeaders:headersArray(i),body:t?t.toString("base64"):void 0}).catch((e=>(this.#n=!1,handleError(e))))}async abort(e="failed",t){if(this.#r.startsWith("data:"))return;const i=errorReasons[e];if(assert(i,"Unknown error code: "+e),assert(this.#i,"Request Interception is not enabled!"),assert(!this.#n,"Request is already handled!"),void 0===t)return this.#q(i);this.#h=i,(void 0===this.#p.priority||t>=this.#p.priority)&&(this.#p={action:InterceptResolutionAction.Abort,priority:t})}async#q(e){if(this.#n=!0,void 0===this._interceptionId)throw new Error("HTTPRequest is missing _interceptionId needed for Fetch.failRequest");await this.#e.send("Fetch.failRequest",{requestId:this._interceptionId,errorReason:e||"Failed"}).catch(handleError)}}const errorReasons={aborted:"Aborted",accessdenied:"AccessDenied",addressunreachable:"AddressUnreachable",blockedbyclient:"BlockedByClient",blockedbyresponse:"BlockedByResponse",connectionaborted:"ConnectionAborted",connectionclosed:"ConnectionClosed",connectionfailed:"ConnectionFailed",connectionrefused:"ConnectionRefused",connectionreset:"ConnectionReset",internetdisconnected:"InternetDisconnected",namenotresolved:"NameNotResolved",timedout:"TimedOut",failed:"Failed"};async function handleError(e){if(["Invalid header"].includes(e.originalMessage))throw e;debugError(e)}