import{assert}from"../util/assert.js";import{createDebuggableDeferred}from"../util/DebuggableDeferred.js";import{EventEmitter}from"./EventEmitter.js";import{HTTPRequest}from"./HTTPRequest.js";import{HTTPResponse}from"./HTTPResponse.js";import{NetworkEventManager}from"./NetworkEventManager.js";import{debugError,isString}from"./util.js";export const NetworkManagerEmittedEvents={Request:Symbol("NetworkManager.Request"),RequestServedFromCache:Symbol("NetworkManager.RequestServedFromCache"),Response:Symbol("NetworkManager.Response"),RequestFailed:Symbol("NetworkManager.RequestFailed"),RequestFinished:Symbol("NetworkManager.RequestFinished")};export class NetworkManager extends EventEmitter{#e;#t;#s;#n=new NetworkEventManager;#r={};#i;#o=new Set;#a=!1;#d=!1;#u=!1;#h={offline:!1,upload:-1,download:-1,latency:0};#l;constructor(e,t,s){super(),this.#e=e,this.#t=t,this.#s=s,this.#e.on("Fetch.requestPaused",this.#c.bind(this)),this.#e.on("Fetch.authRequired",this.#q.bind(this)),this.#e.on("Network.requestWillBeSent",this.#g.bind(this)),this.#e.on("Network.requestServedFromCache",this.#E.bind(this)),this.#e.on("Network.responseReceived",this.#R.bind(this)),this.#e.on("Network.loadingFinished",this.#p.bind(this)),this.#e.on("Network.loadingFailed",this.#w.bind(this)),this.#e.on("Network.responseReceivedExtraInfo",this.#v.bind(this))}initialize(){if(this.#l)return this.#l.valueOrThrow();this.#l=createDebuggableDeferred("NetworkManager initialization timed out");const e=Promise.all([this.#t?this.#e.send("Security.setIgnoreCertificateErrors",{ignore:!0}):null,this.#e.send("Network.enable")]),t=this.#l;return e.then((()=>{t.resolve()})).catch((e=>{t.reject(e)})),this.#l.valueOrThrow()}async authenticate(e){this.#i=e,await this.#m()}async setExtraHTTPHeaders(e){this.#r={};for(const t of Object.keys(e)){const s=e[t];assert(isString(s),`Expected value of header "${t}" to be String, but "${typeof s}" is found.`),this.#r[t.toLowerCase()]=s}await this.#e.send("Network.setExtraHTTPHeaders",{headers:this.#r})}extraHTTPHeaders(){return Object.assign({},this.#r)}inFlightRequestsCount(){return this.#n.inFlightRequestsCount()}async setOfflineMode(e){this.#h.offline=e,await this.#f()}async emulateNetworkConditions(e){this.#h.upload=e?e.upload:-1,this.#h.download=e?e.download:-1,this.#h.latency=e?e.latency:0,await this.#f()}async#f(){await this.#e.send("Network.emulateNetworkConditions",{offline:this.#h.offline,latency:this.#h.latency,uploadThroughput:this.#h.upload,downloadThroughput:this.#h.download})}async setUserAgent(e,t){await this.#e.send("Network.setUserAgentOverride",{userAgent:e,userAgentMetadata:t})}async setCacheEnabled(e){this.#u=!e,await this.#k()}async setRequestInterception(e){this.#a=e,await this.#m()}async#m(){const e=this.#a||!!this.#i;e!==this.#d&&(this.#d=e,e?await Promise.all([this.#k(),this.#e.send("Fetch.enable",{handleAuthRequests:!0,patterns:[{urlPattern:"*"}]})]):await Promise.all([this.#k(),this.#e.send("Fetch.disable")]))}#I(){return this.#u}async#k(){await this.#e.send("Network.setCacheDisabled",{cacheDisabled:this.#I()})}#g(e){if(!this.#a||e.request.url.startsWith("data:"))this.#M(e,void 0);else{const{requestId:t}=e;this.#n.storeRequestWillBeSent(t,e);const s=this.#n.getRequestPaused(t);if(s){const{requestId:n}=s;this.#b(e,s),this.#M(e,n),this.#n.forgetRequestPaused(t)}}}#q(e){let t="Default";this.#o.has(e.requestId)?t="CancelAuth":this.#i&&(t="ProvideCredentials",this.#o.add(e.requestId));const{username:s,password:n}=this.#i||{username:void 0,password:void 0};this.#e.send("Fetch.continueWithAuth",{requestId:e.requestId,authChallengeResponse:{response:t,username:s,password:n}}).catch(debugError)}#c(e){!this.#a&&this.#d&&this.#e.send("Fetch.continueRequest",{requestId:e.requestId}).catch(debugError);const{networkId:t,requestId:s}=e;if(!t)return void this.#N(e);const n=(()=>{const s=this.#n.getRequestWillBeSent(t);if(!s||s.request.url===e.request.url&&s.request.method===e.request.method)return s;this.#n.forgetRequestWillBeSent(t)})();n?(this.#b(n,e),this.#M(n,s)):this.#n.storeRequestPaused(t,e)}#b(e,t){e.request.headers={...e.request.headers,...t.request.headers}}#N(e){const t=e.frameId?this.#s.frame(e.frameId):null,s=new HTTPRequest(this.#e,t,e.requestId,this.#a,e,[]);this.emit(NetworkManagerEmittedEvents.Request,s),s.finalizeInterceptions()}#M(e,t){let s=[];if(e.redirectResponse){let n=null;if(e.redirectHasExtraInfo&&(n=this.#n.responseExtraInfo(e.requestId).shift(),!n))return void this.#n.queueRedirectInfo(e.requestId,{event:e,fetchRequestId:t});const r=this.#n.getRequest(e.requestId);r&&(this.#T(r,e.redirectResponse,n),s=r._redirectChain)}const n=e.frameId?this.#s.frame(e.frameId):null,r=new HTTPRequest(this.#e,n,t,this.#a,e,s);this.#n.storeRequest(e.requestId,r),this.emit(NetworkManagerEmittedEvents.Request,r),r.finalizeInterceptions()}#E(e){const t=this.#n.getRequest(e.requestId);t&&(t._fromMemoryCache=!0),this.emit(NetworkManagerEmittedEvents.RequestServedFromCache,t)}#T(e,t,s){const n=new HTTPResponse(this.#e,e,t,s);e._response=n,e._redirectChain.push(e),n._resolveBody(new Error("Response body is unavailable for redirect responses")),this.#C(e,!1),this.emit(NetworkManagerEmittedEvents.Response,n),this.emit(NetworkManagerEmittedEvents.RequestFinished,e)}#F(e,t){const s=this.#n.getRequest(e.requestId);if(!s)return;this.#n.responseExtraInfo(e.requestId).length&&debugError(new Error("Unexpected extraInfo events for request "+e.requestId)),e.response.fromDiskCache&&(t=null);const n=new HTTPResponse(this.#e,s,e.response,t);s._response=n,this.emit(NetworkManagerEmittedEvents.Response,n)}#R(e){const t=this.#n.getRequest(e.requestId);let s=null;!t||t._fromMemoryCache||!e.hasExtraInfo||(s=this.#n.responseExtraInfo(e.requestId).shift(),s)?this.#F(e,s):this.#n.queueEventGroup(e.requestId,{responseReceivedEvent:e})}#v(e){const t=this.#n.takeQueuedRedirectInfo(e.requestId);if(t)return this.#n.responseExtraInfo(e.requestId).push(e),void this.#M(t.event,t.fetchRequestId);const s=this.#n.getQueuedEventGroup(e.requestId);if(s)return this.#n.forgetQueuedEventGroup(e.requestId),this.#F(s.responseReceivedEvent,e),s.loadingFinishedEvent&&this.#P(s.loadingFinishedEvent),void(s.loadingFailedEvent&&this.#H(s.loadingFailedEvent));this.#n.responseExtraInfo(e.requestId).push(e)}#C(e,t){const s=e._requestId,n=e._interceptionId;this.#n.forgetRequest(s),void 0!==n&&this.#o.delete(n),t&&this.#n.forget(s)}#p(e){const t=this.#n.getQueuedEventGroup(e.requestId);t?t.loadingFinishedEvent=e:this.#P(e)}#P(e){const t=this.#n.getRequest(e.requestId);t&&(t.response()&&t.response()?._resolveBody(null),this.#C(t,!0),this.emit(NetworkManagerEmittedEvents.RequestFinished,t))}#w(e){const t=this.#n.getQueuedEventGroup(e.requestId);t?t.loadingFailedEvent=e:this.#H(e)}#H(e){const t=this.#n.getRequest(e.requestId);if(!t)return;t._failureText=e.errorText;const s=t.response();s&&s._resolveBody(null),this.#C(t,!0),this.emit(NetworkManagerEmittedEvents.RequestFailed,t)}}