const styles=new CSSStyleSheet;styles.replaceSync('/*\n * Copyright (c) 2015 The Chromium Authors. All rights reserved.\n * Use of this source code is governed by a BSD-style license that can be\n * found in the LICENSE file.\n */\n\n.filtered-list-widget {\n  display: flex;\n  flex-direction: column;\n  flex: auto;\n  border: 1px solid transparent;\n\n  --override-filtered-list-widget-highlight-text-background-color: rgb(255 255 255 / 25%);\n}\n\n.-theme-with-dark-background .filtered-list-widget,\n:host-context(.-theme-with-dark-background) .filtered-list-widget {\n  --override-filtered-list-widget-highlight-text-background-color: rgb(255 255 255 / 75%);\n}\n\n.hbox {\n  flex: 0 0 40px;\n  align-items: center;\n}\n\n.filtered-list-widget-hint {\n  color: var(--color-text-disabled);\n  padding: 12px;\n}\n\ndevtools-text-prompt {\n  flex-grow: 1;\n  font-size: 14px;\n  font-family: ".SFNSDisplay-Regular", "Helvetica Neue", "Lucida Grande", sans-serif;\n  line-height: 16px;\n  padding: 12px;\n}\n\n.filtered-list-widget-progress {\n  flex: none;\n  background: rgb(0 0 0 / 20%); /* stylelint-disable-line plugin/use_theme_colors */\n  /* See: crbug.com/1152736 for color variable migration. */\n  height: 1px;\n}\n\n.filtered-list-widget-progress-bar {\n  background-color: var(--color-primary-variant);\n  height: 2px;\n  width: 100%;\n  transform: scaleX(0);\n  transform-origin: top left;\n  opacity: 100%;\n  transition: none;\n}\n\n.filtered-widget-progress-fade {\n  opacity: 0%;\n  transition: opacity 500ms;\n}\n\n.filtered-list-widget .vbox > div.container {\n  flex: auto;\n  overflow-x: hidden;\n  overflow-y: auto;\n}\n\n.filtered-list-widget-item-wrapper {\n  color: var(--color-text-primary);\n  display: flex;\n  border-bottom: 1px solid var(--color-details-hairline-light);\n  font-family: ".SFNSDisplay-Regular", "Helvetica Neue", "Lucida Grande", sans-serif;\n  padding-left: 8px;\n  padding-right: 8px;\n}\n\n.filtered-list-widget-item-wrapper devtools-icon {\n  align-self: center;\n  flex: none;\n  padding-right: 8px;\n}\n\n.filtered-list-widget-item-wrapper.selected {\n  background-color: var(--color-primary-old);\n}\n\n.filtered-list-widget-item {\n  white-space: nowrap;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  align-self: center;\n  font-size: 12px;\n  flex: auto;\n}\n\n.filtered-list-widget-item.is-ignore-listed {\n  opacity: 50%;\n}\n\n.filtered-list-widget-item.two-rows span.highlight {\n  color: var(--color-primary-old);\n}\n\n.filtered-list-widget-item.one-row span.highlight {\n  font-weight: bold;\n}\n\n.filtered-list-widget-item .filtered-list-widget-title {\n  flex: initial;\n  overflow: hidden;\n  text-overflow: ellipsis;\n}\n\n.filtered-list-widget-item .filtered-list-widget-subtitle {\n  flex: none;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  color: var(--color-text-secondary);\n  display: flex;\n  white-space: pre;\n}\n\n.filtered-list-widget-item .filtered-list-widget-subtitle .first-part {\n  flex-shrink: 1000;\n  overflow: hidden;\n  text-overflow: ellipsis;\n}\n\n.filtered-list-widget-item-wrapper .tag {\n  padding: 0 12px;\n  border-radius: 4px;\n  line-height: 24px;\n  height: 24px;\n  align-self: center;\n  flex-shrink: 0;\n}\n\n.filtered-list-widget-item-wrapper .deprecated-tag {\n  font-size: 11px;\n  color: var(--color-text-secondary);\n}\n\n.filtered-list-widget-item-wrapper.selected .deprecated-tag {\n  color: var(--color-background);\n}\n\n.-theme-with-dark-background .filtered-list-widget-item-wrapper.selected .deprecated-tag,\n:host-context(.-theme-with-dark-background) .filtered-list-widget-item-wrapper.selected .deprecated-tag {\n  color: var(--color-background);\n  opacity: 80%;\n}\n\n.filtered-list-widget-item-wrapper.selected .filtered-list-widget-item span.highlight {\n  color: var(--color-background);\n  background-color: var(--override-filtered-list-widget-highlight-text-background-color);\n}\n\n.filtered-list-widget-item-wrapper.selected .filtered-list-widget-title,\n.filtered-list-widget-item-wrapper.selected .filtered-list-widget-subtitle,\n.filtered-list-widget-item-wrapper.selected .tag {\n  color: var(--color-background);\n}\n\n.filtered-list-widget-item-wrapper.selected devtools-icon {\n  --icon-color: var(--icon-force-white);\n}\n\n.filtered-list-widget-item.one-row {\n  height: 36px;\n  line-height: 20px;\n  padding-top: 8px;\n  padding-bottom: 8px;\n  display: flex;\n}\n\n.filtered-list-widget-item.one-row .filtered-list-widget-title {\n  padding-right: 8px;\n}\n\n.filtered-list-widget-item.two-rows {\n  height: 45px;\n  padding-top: 8px;\n  padding-bottom: 8px;\n}\n\n.filtered-list-widget-item.two-rows .filtered-list-widget-title {\n  font-weight: bold;\n}\n\n.not-found-text {\n  height: 34px;\n  line-height: 34px;\n  padding-left: 8px;\n  font-style: italic;\n  color: var(--color-text-disabled);\n  background: var(--color-background-elevation-0);\n}\n\n.quickpick-description {\n  flex: none;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  color: var(--color-text-disabled);\n  padding-left: 15px;\n}\n\n@media (forced-colors: active) {\n  .filtered-list-widget {\n    forced-color-adjust: none;\n    border-color: ButtonText;\n  }\n\n  .filtered-list-widget-item-wrapper .filtered-list-widget-title,\n  .filtered-list-widget-item-wrapper .filtered-list-widget-subtitle,\n  .quickpick-description {\n    color: ButtonText;\n  }\n\n  .filtered-list-widget-item-wrapper.selected {\n    background-color: Highlight;\n  }\n\n  .filtered-list-widget-item-wrapper.selected .filtered-list-widget-item .filtered-list-widget-title,\n  .filtered-list-widget-item-wrapper.selected .filtered-list-widget-item .filtered-list-widget-subtitle {\n    color: HighlightText;\n  }\n\n  devtools-text-prompt {\n    border-color: ButtonText;\n  }\n}\n\n/*# sourceURL=filteredListWidget.css */\n');export default styles;